#include <windows.h>
#include "com_example_autorefresh_win32_internal_Win32Natives.h"

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FindFirstChangeNotification
 * Signature: ([BZI)J
 */
JNIEXPORT jlong JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FindFirstChangeNotification
(JNIEnv * env, jclass this, jbyteArray lpPathName, jboolean bWatchSubtree, jint dwNotifyFilter) {
	jlong result;
	jbyte *bytes = (*env)->GetByteArrayElements(env, lpPathName, 0);

	result = (jlong) FindFirstChangeNotification(bytes, bWatchSubtree, dwNotifyFilter);
	(*env)->ReleaseByteArrayElements(env, lpPathName, bytes, 0);

	return result;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FindCloseChangeNotification
 * Signature: (J)Z
 */
JNIEXPORT jboolean JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FindCloseChangeNotification
(JNIEnv *env, jclass this, jlong hChangeHandle){
	return (jboolean) FindCloseChangeNotification((HANDLE) hChangeHandle);
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FindNextChangeNotification
 * Signature: (J)Z
 */
JNIEXPORT jboolean JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FindNextChangeNotification
(JNIEnv *env, jclass this, jlong hChangeHandle){
	return (jboolean) FindNextChangeNotification((HANDLE) hChangeHandle);
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    WaitForMultipleObjects
 * Signature: (I[JZI)I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_WaitForMultipleObjects
(JNIEnv *env, jclass this, jint nCount, jlongArray lpHandles, jboolean bWaitAll, jint dwMilliseconds) {
	int i;
	jint result;
	HANDLE handles[MAXIMUM_WAIT_OBJECTS];
	jlong *handlePointers = (*env)->GetLongArrayElements(env, lpHandles, 0);

	for (i = 0; i < nCount; i++) {
		handles[i] = (HANDLE) handlePointers[i];
	}

	result = WaitForMultipleObjects(nCount, handles, bWaitAll, dwMilliseconds);
	(*env)->ReleaseLongArrayElements(env, lpHandles, handlePointers, 0);

	return result;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    GetLastError
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_GetLastError
(JNIEnv *env, jclass this){
	return GetLastError();
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_LAST_WRITE
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1LAST_1WRITE
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_LAST_WRITE;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_DIR_NAME
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1DIR_1NAME
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_DIR_NAME;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_ATTRIBUTES
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1ATTRIBUTES
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_ATTRIBUTES;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_SIZE
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1SIZE
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_SIZE;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_FILE_NAME
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1FILE_1NAME
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_FILE_NAME;
}


/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    FILE_NOTIFY_CHANGE_SECURITY
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_FILE_1NOTIFY_1CHANGE_1SECURITY
(JNIEnv *env, jclass this) {
	return FILE_NOTIFY_CHANGE_SECURITY;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    MAXIMUM_WAIT_OBJECTS
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_MAXIMUM_1WAIT_1OBJECTS
(JNIEnv *env, jclass this) {
	return MAXIMUM_WAIT_OBJECTS;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    MAX_PATH
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_MAX_1PATH
(JNIEnv *env, jclass this) {
	return MAX_PATH;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    INFINITE
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_INFINITE
(JNIEnv *env, jclass this) {
	return INFINITE;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    WAIT_OBJECT_0
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_WAIT_1OBJECT_10
(JNIEnv *env, jclass this) {
	return WAIT_OBJECT_0;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    WAIT_FAILED
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_WAIT_1FAILED
(JNIEnv *env, jclass this) {
	return WAIT_FAILED;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    WAIT_TIMEOUT
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_WAIT_1TIMEOUT
(JNIEnv *env, jclass this) {
	return WAIT_TIMEOUT;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    ERROR_INVALID_HANDLE
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_ERROR_1INVALID_1HANDLE
(JNIEnv *env, jclass this) {
	return ERROR_INVALID_HANDLE;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    ERROR_SUCCESS
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_ERROR_1SUCCESS
(JNIEnv *env, jclass this) {
	return ERROR_SUCCESS;
}

/*
 * Class:     com_example_autorefresh_win32_internal_Win32Natives
 * Method:    INVALID_HANDLE_VALUE
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_com_example_autorefresh_win32_internal_Win32Natives_INVALID_1HANDLE_1VALUE
(JNIEnv * env, jclass this) {
	return (jlong)INVALID_HANDLE_VALUE;
}
